{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program ROBOT;

type dvect=array[0..210] of double;
     boolvect=array[0..210] of boolean;
     coada=array[0..40900] of byte;

const eps:double=1e-6;

var fin,fout:text;
    i,j,k,m,n,last,vi,vj,act,po:integer;
    xp,yp:array[0..210] of double;
    np,st:array[1..52] of integer;
    xs,ys,xf,yf,xi,yi,xm1,xm2,ym1,ym2,xxm1,xxm2,yym1,yym2:double;
    dist:array[0..202] of ^dvect;
    ppo:array[0..210] of integer;
    a1,b1,c1,a2,b2,c2,min:double;
    okyet:boolean;
    dmin:array[0..202] of double;
    tata,rec:array[0..202] of integer;
    sel:array[0..202] of boolean;
    co:^coada;

begin
assign(fin,'ROBOT.IN');
reset(fin);

readln(fin,xp[0],yp[0]); readln(fin,xf,yf);
ppo[0]:=0;

readln(fin,n);

st[1]:=1;
for k:=1 to n do
  begin
    readln(fin,np[k]);
    for i:=1 to np[k] do
      begin
        readln(fin,xp[st[k]+i-1],yp[st[k]+i-1]);
        ppo[st[k]+i-1]:=k;
      end;

    st[k+1]:=st[k]+np[k];
  end;

close(fin);

xp[st[k+1]]:=xf; yp[st[k+1]]:=yf;
ppo[st[k+1]]:=n+1;

last:=st[k+1];

for i:=0 to last do
  begin
    new(dist[i]);
    fillchar(dist[i]^,sizeof(dist[i]^),0);
  end;

for i:=0 to last-1 do
  for j:=i+1 to last do
    begin
      dist[i]^[j]:=sqrt((xp[i]-xp[j])*(xp[i]-xp[j])+
                       (yp[i]-yp[j])*(yp[i]-yp[j]));
      dist[j]^[i]:=dist[i]^[j];
    end;

new(co);
fillchar(co^,sizeof(co^),0);

fillchar(tata,sizeof(tata),0);
fillchar(sel,sizeof(sel),false);

for i:=1 to last do
  dmin[i]:=1e10;

dmin[0]:=0; sel[0]:=true; act:=0;
tata[0]:=-1;
i:=0;

while (not sel[last]) do
  begin

  for j:=1 to last do
  if (not sel[j]) and (dmin[j]>dmin[i]+dist[i]^[j]) then
  begin
    if (ppo[i]=ppo[j]) then
      begin
        if ((abs(i-j)=1) or (j-i=np[ppo[i]]-1)) then
          begin
            dmin[j]:=dmin[i]+dist[i]^[j];
            tata[j]:=i;
          end;
      end
    else
      begin
        a1:=yp[i]-yp[j];
        b1:=xp[j]-xp[i];
        c1:=xp[i]*yp[j]-xp[j]*yp[i];

        if (xp[i]>xp[j]) then
          begin
            xm1:=xp[j]; xm2:=xp[i];
          end
        else
          begin
            xm1:=xp[i]; xm2:=xp[j];
          end;

        if (yp[i]>yp[j]) then
          begin
            ym1:=yp[j]; ym2:=yp[i];
          end
        else
          begin
            ym1:=yp[i]; ym2:=yp[j];
          end;

        okyet:=true;

        for k:=1 to last-1 do
          if (k<>i) and (k<>j) then
          begin
            vi:=k;
            if (ppo[k+1]=ppo[k]) then vj:=k+1
            else vj:=st[ppo[k]];

            if (vj=i) or (vj=j) then continue;

            if ((xp[vi]<xm1) and (xp[vj]<xm1)) or
               ((xp[vi]>xm2) and (xp[vj]>xm2)) or
               ((yp[vi]<ym1) and (yp[vj]<ym1)) or
               ((yp[vi]>ym2) and (yp[vj]>ym2)) then
               continue;

            a2:=yp[vi]-yp[vj];
            b2:=xp[vj]-xp[vi];
            c2:=xp[vi]*yp[vj]-xp[vj]*yp[vi];

            if (abs(a2*b1-a1*b2)>eps) then
              begin
                xi:=(b2*c1-b1*c2)/(a2*b1-a1*b2);
                yi:=(c2*a1-c1*a2)/(a2*b1-a1*b2);

                if (xp[vi]>xp[vj]) then
                  begin
                    xxm1:=xp[vj]; xxm2:=yp[vj];
                  end
                else
                  begin
                    xxm1:=xp[vi]; xxm2:=xp[vj];
                  end;

                if (yp[vi]>yp[vj]) then
                  begin
                    yym1:=yp[vj]; yym2:=yp[vi];
                  end
                else
                  begin
                    yym1:=yp[vi]; yym2:=yp[vj];
                  end;


                if (
                   ((xi>xm1) or (abs(xi-xm1)<eps)) and
                   ((xi<xm2) or (abs(xi-xm2)<eps)) and
                   ((yi>ym1) or (abs(yi-ym1)<eps)) and
                   ((yi<ym2) or (abs(yi-ym2)<eps)) and
                   ((xi>xxm1) or (abs(xi-xxm1)<eps)) and
                   ((xi<xxm2) or (abs(xi-xxm2)<eps)) and
                   ((yi>yym1) or (abs(yi-yym1)<eps)) and
                   ((yi<yym2) or (abs(yi-yym2)<eps))
                   )
                then begin
                       okyet:=false;
                       break;
                     end;
              end;
          end;

        if (okyet) then
          begin
            tata[j]:=i;
            dmin[j]:=dmin[i]+dist[i]^[j];
          end;
      end;
   end;

   min:=1e9;
   for act:=1 to last do
     if (not sel[act]) and (min>dmin[act]) then
       begin
         i:=act;
         min:=dmin[act];
       end;

   sel[i]:=true;
  end;


fillchar(rec,sizeof(rec),0);
k:=last; m:=1; rec[1]:=last;

while (tata[k]>-1) do
  begin
    k:=tata[k];
    inc(m);
    rec[m]:=k;
  end;

assign(fout,'ROBOT.OUT');
rewrite(fout);
writeln(fout,m);
for i:=m downto 1 do
  writeln(fout,xp[rec[i]]:0:3,' ',yp[rec[i]]:0:3);
close(fout);
end.
